/*
 */
#include <string.h>
#include <time.h>
#include <string.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef __NETWARE__
#include <process.h>
#include <direct.h>
#include <nwsemaph.h>
#else
#include <dir.h>
#endif

#include "logs.h"

#ifndef __NETWARE__
static void EnterCritSec() {}
static void ExitCritSec() {}
blaaa#define ConsolePrintf printf
#endif

void MyProcessThread(void *);

LOGFILE *logs;
LONG SigKill;
char *logfilename = NULL;
int maxloglines;                          // maximum is 10 cached lines
int maxlogtime;                            // maximum logged time out!

extern int NAWriteLog(LOGFILE *log);

char *MakeLogFile(char *dest,
      long ipaddr,
      char *url,
		  int day,
		  int month,
		  int year,
		  int hour,
		  int minute,
		  int second)
{
 int x,y;
 char temp[0x10];

 y=0;
 x=0;

 while(logfilename[x])
  {
   if (logfilename[x]=='%' )
   {
    switch (logfilename[x+1])
    {
      case '%':
              dest[y++]='%';
              x++;
              break;
      case 'a':
      case 'A':
              sprintf(temp,"%lx",ipaddr);
              strcpy(dest+y,temp);
              y+=strlen(temp);
              x++;
              break;
      case 'd':
      case 'D':
              sprintf(temp,"%u",day);
              strcpy(dest+y,temp);
              y+=strlen(temp);
              x++;
              break;
      case 'm':
      case 'M':
              sprintf(temp,"%u",month);
              strcpy(dest+y,temp);
              y+=strlen(temp);
              x++;
	      break;
      case 'y':
              sprintf(temp,"%02u",year%100);
              strcpy(dest+y,temp);
              y+=strlen(temp);
              x++;
              break;
      case 'Y':
              sprintf(temp,"%04u",year);
              strcpy(dest+y,temp);
              y+=strlen(temp);
              x++;
              break;
      case 'H':
      case 'h':
              sprintf(temp,"%02u",hour);
              strcpy(dest+y,temp);
              y+=strlen(temp);
              x++;
              break;
      case 'n':
      case 'N':
              sprintf(temp,"%02u",minute);
              strcpy(dest+y,temp);
              y+=strlen(temp);
              x++;
              break;
      case 's':
      case 'S':
              sprintf(temp,"%02u",second);
              strcpy(dest+y,temp);
              y+=strlen(temp);
              x++;
              break;
      default:
	      dest[y++]='%';
              break;
    }

   }else
   {
    dest[y++]=logfilename[x];
   }

   x++;
  }

 dest[y]=0;
 x=0;
 for (y=0;y<strlen(dest);y++)
  {
   if (dest[y]=='\\')
    {
     if (dest[y+1]!='\\' )
      dest[x++] = dest[y];
    }else
    {
     dest[x++] = dest[y];
    }
  }
 dest[x]=0;
 return dest;
}

void ProcessLogQueue()
{
 LOGFILE *lg,*lp,*f;

// ConsolePrintf("\r[Queue]\n");
 EnterCritSec();
 if (logs)
  {
   lg=logs;
   lp=0;
   while (lg)
    {
     f = lg;
//     ConsolePrintf("\rProcessing %s (%u-%u)\n",f->filename,
//                   f->firsttime,time(NULL));

     if ( (f->lines>maxloglines) || (f->firsttime+maxlogtime<time(NULL)) )
      {
//       ConsolePrintf("\r[WriteIt]\n");
       NAWriteLog(f);
       if (lp)
        lp->next=lg->next;
         else
          logs=lg->next;
       lg = lg->next;
       delete f->filename;
       delete f;
      }else
      {
       lg = lg->next;
       lp=f;
      }
    }
  }
 ExitCritSec();
// ConsolePrintf("\r[/Queue]\n");
}

void AppendLogMessage(LOGFILE *n,
          long ipaddr,
          char *url,
		      long stime)
{
 LOGRECORD *p,*l,*m;
 char *line = new char [0x1000];       // 0x1000 to snad neprekroci.. ;-)
 struct tm *tm;
 char xxxtime[0x20];

// ConsolePrintf("\r[in append log message]\n");
 EnterCritSec();
 tm = localtime((unsigned long const *)&stime);


 if (!line)
  {
   ExitCritSec();
   //LOGERR
   return;
  }

 strcpy(xxxtime,asctime(tm));
 if (xxxtime[strlen(xxxtime)-1]=='\n')
  xxxtime[strlen(xxxtime)-1]=0;

 sprintf(line,"[%s] %u.%u.%u.%u - %s\n",
   xxxtime,
   (ipaddr)&0xFF,
   (ipaddr>>8)&0xFF,
   (ipaddr>>16)&0xFF,
   (ipaddr>>24)&0xFF,
   url);
// ConsolePrintf("\r[line is %s]\n",line);


 l = new LOGRECORD;
 if(!l)
  {
   //LOGERR
   delete line;
   return;
  }

 l->next=0;
 l->str = line;

// ConsolePrintf("appending1\n");
// ConsolePrintf("\r[Append %s]\n",n->filename);

// ConsolePrintf("\r[n->lastline=%x]\n",n->lastline);
 if(n->lastline)
  n->lastline->next=l;
   else
    n->line=l;
 n->lastline=l;
 n->lines++;
// ConsolePrintf("\r[ok]\n");
 ExitCritSec();
}

void NALog(long ipaddr,
           char *url,
           long stime)

{
 char logname[0x100];
 struct tm *tm;
 time_t timer = time(NULL);
 LOGFILE *n,*p,*f;

 if (!logfilename)
  {
   //ConsolePrintf("\r[ !!! Jeste nejsem inizializovany !!! ]\n");
   return;
  }

 //ConsolePrintf("%s/%utime/%ulines",logfilename,maxlogtime,maxloglines);

 tm = localtime(&timer);
 EnterCritSec();

// ConsolePrintf("\r[MakeLogFileBegin]\n");
 MakeLogFile(logname,ipaddr,url,tm->tm_mday,tm->tm_mon,tm->tm_year+1900,tm->tm_hour,tm->tm_min,tm->tm_sec);
// ConsolePrintf("\r[MakeLogFileEnd, %s]\n",logname);

// ConsolePrintf("\r[Logs = %x]\n",logs);
 n = logs;
 p = 0;
// ConsolePrintf("adding\n");
 while (n)
  {
//   ConsolePrintf("? %s\n",n->filename);
   if (!stricmp(logname,n->filename))
    {
     AppendLogMessage(n,ipaddr,url,stime);
     // ?
     //delete n->filename;
     //delete n;
     ExitCritSec();
     return;
    }
   p=n;
   n=n->next;
  }
// ConsolePrintf("[not found, adding]\n");


 f = new LOGFILE;
 if (!f)
   {
    //LOGERR
    ExitCritSec();
    return ;
   }
 f->filename = strdup(logname);
 if (!f->filename)
  {
   delete f;
   //LOGERR
   ExitCritSec();
   return;
  }
 f->firsttime=stime;
 f->lines=0;
 f->line=NULL;
 f->lastline=0;
 f->next=0;
// ConsolePrintf("[Add it to link]\n");
 if (logs)
  p->next=f;
   else
    logs=f;

// ConsolePrintf("[Appending message]\n");
 AppendLogMessage(f,ipaddr,url,stime);
 ExitCritSec();
// ConsolePrintf("\r[all ok]\n");
}

void MakeLogDir(char *filename)
{
 char path[0x100];
 char *lastslash;
 int x;

 lastslash=0;
 strncpy(path,filename,0x100);
 path[0xFF]=0;

 // strip filename
 for (x=0;x<strlen(path);x++)
  if ((path[x]=='/')||(path[x]=='\\'))
   lastslash = path+x;
 if (lastslash)
  *lastslash=0;

 for (x=0;x<strlen(path);x++)
  if ((path[x]=='/')||(path[x]=='\\'))
   {
    path[x]=0;
    mkdir(path);
    path[x]='\\';
   }
 mkdir(path);
}

int NAWriteLog(LOGFILE *log)
{
 FILE *f;
 LOGRECORD *rec,*p;

 if (!logfilename)
   return 0;

 //ConsolePrintf("\r[Flushing %s]\n",log->filename);

 if (!log->lines)
  return 0;

 MakeLogDir(log->filename);

 f = fopen(log->filename,"at");
 if (!f)
  {
   //ConsolePrintf("\r[Flush ERROR: Unable to open!]\n");
   rec = log->line;
   while (rec)
    {
     p=rec;
     rec = rec->next;
     if (p->str)
      delete p->str;
     delete p;
    }
   log->line=0;
   log->lastline=0;
   log->lines=0;
   return -1;
  }

 rec = log->line;
 while (rec)
  {
   if (rec->str)
    fprintf(f,"%s",rec->str);
   p=rec;
   rec = rec->next;
   if (p->str)
    delete p->str;
   delete p;
  }

 log->line=0;
 log->lastline=0;
 log->lines=0;

 fclose(f);
 return 0;
}

int NAInitLogs(char *_filename,int _maxloglines,int _maxlogtime)
{
 if (!_filename)
  return 0;
 if (_filename[0]==0)
  return 0;
 SigKill = OpenLocalSemaphore(0);
 if ( SigKill==-1 )
  {
    return -1;
  }

 /*SigKilled = OpenLocalSemaphore(0);
 if ( SigKilled==-1 )
  {
    CloseLocalSemaphore(SigKill);
    return -1;
  }*/
 logfilename = strdup(_filename);
 if (!logfilename)
  {
   CloseLocalSemaphore(SigKill);
   return -1;
  }
 BeginThread(MyProcessThread,(void*)NULL,4096,(void *)NULL);
 maxloglines = _maxloglines;
 maxlogtime = _maxlogtime;
 logs=0;
 return 0;
}

void FinishLogs()
{
 EnterCritSec();
 if (logs)
  {
   LOGFILE *f;
   while (logs)
    {
     f = logs;
     NAWriteLog(f);
     logs = logs->next;
     if (f->filename) delete f->filename;
     delete f;
    }
  }
 logs=0;
 ExitCritSec();
}

void NAStopLogs()
{
 if (!logfilename)
  return;
 ConsolePrintf("\rNoadvert.NLM: Stopping logging process\n");
 SignalLocalSemaphore(SigKill);
 delay(1000);
 if (SigKill != -1)
   CloseLocalSemaphore(SigKill);
 SigKill = -1;
 //WaitOnLocalSemaphore(SigKilled);
 //CloseLocalSemaphore(SigKilled);
 FinishLogs();
 if (logfilename)
  delete logfilename;
 logfilename=0;
}

void MyProcessThread(void *ja_nevim)
{
 RenameThread(GetThreadID(),"Noadvert:LOG");
 while (1)
 {
  if (!TimedWaitOnLocalSemaphore(SigKill,200))
   break;
  ProcessLogQueue();
 }
 EnterCritSec();
 CloseLocalSemaphore(SigKill);
 SigKill = -1;
 ExitCritSec();
 //SignalLocalSemaphore(SigKilled);
 ConsolePrintf("\rNoadvert.NLM: Logging stopped\n");
}

