#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <malloc.h>
#include <direct.h>

#include "rules.h"

#include "match.h"

char ProxyCache[0x40];
int ProxyPort,MyPort;
char StatusURL[0x100];
char StatusPassword[0x40];
char LogFile[0x100];
FailTable *Fail;
MimeTable *Mime;

void AppendFail(char *what,char *newurl)
{
 FailTable *t = new FailTable,*l;

 //ConsolePrintf("AppendRule:[%s]\n",what);
 if ( !t )
 {
  ConsolePrintf("SMSSMTP:Not enough memory for rule [%s]\n",what);
  return;
 }
 t->url = (char *)malloc(strlen(what)+1);
 if ( !t->url )
 {
  ConsolePrintf("SMSSMTP:Not enough memory for rule [%s]\n",what);
  delete t;
  return;
 }
 strcpy(t->url,what);
 if ( newurl )
  {
   t->newurl = (char *)malloc(strlen(newurl)+1);
   if ( !t->newurl )
    {
     ConsolePrintf("SMSSMTP:Not enough memory for rule [%s]\n",what);
     delete t;
     return;
    }
   strcpy(t->newurl,newurl);
  }
 t->next=0;
 if (Fail)
 {
  l = Fail;
  while ( l->next ) l = l->next;
  l->next = t;
 }else
  Fail = t;
}

void AppendMime(char *ext,char *type)
{
 MimeTable *t = new MimeTable,*l;

 //ConsolePrintf("AppendRule:[%s]\n",what);
 if (!t)
 {
  ConsolePrintf("SMSSMTP:Not enough memory for rule [%s]\n",ext);
  return;
 }
 t->ext = (char *)malloc(strlen(ext)+1);
 if ( !t->ext )
 {
  ConsolePrintf("SMSSMTP:Not enough memory for rule [%s]\n",ext);
  delete t;
  return;
 }
 strcpy(t->ext,ext);
 t->type = (char *)malloc(strlen(type)+1);
 if (!t->type)
  {
   ConsolePrintf("SMSSMTP:Not enough memory for rule [%s]\n",ext);
   delete t;
   return;
  }
 strcpy(t->type,type);
 t->next=0;
 if (Mime)
 {
  l = Mime;
  while ( l->next ) l = l->next;
  l->next = t;
 }else
  Mime = t;
}

/*-----------------05-19-98 05:45pm-----------------
 Returns 0, when NOT in ruletable, else 1.
--------------------------------------------------*/
int VerifyFail(char *what,char **newurl)
{
  FailTable *l;

  l = Fail;
  while (l)
   {
    if (strmatchi(what,l->url))
     {
      if (newurl) *newurl = l->newurl;
      return 1;
     }
    l = l->next;
   }
  if (newurl) *newurl = 0;
  return 0;
}


/*-----------------05-19-98 05:45pm-----------------
 Returns 0, when NOT in ruletable, else 1.
--------------------------------------------------*/
char *GetMime(char *url)
{
  MimeTable *l;

  l = Mime;
  while (l)
   {
    //ConsolePrintf("%s:%s\n",url+strlen(url)-strlen(l->ext),l->ext);
    if ( strlen(url)>strlen(l->ext) )
    if (!strnicmp(url+strlen(url)-strlen(l->ext),l->ext,strlen(l->ext)))
      return l->type;
    l = l->next;
   }
  return "text/plain";
}

void LoadTables()
{
 FILE *f;
 char line[0x100];
 char *cmd,*what,*arg2;

 // NULL all tables
 Fail=0;
 MyPort=0;
 Mime=0;
 strcpy(StatusURL,"");
 strcpy(StatusPassword,"");

 f = fopen("SYS:\\ETC\\NOADVERT.CFG","rt");
 if ( !f )
 {
  ConsolePrintf("NOADV: Cannot open rule file \r\n");
  return ;
 }
 while ( fgets(line,0x100,f) )
 {
  if ( line[strlen(line)-1]=='\n' )  line[strlen(line)-1]=0;
  if ( strchr(line,'#') ) *strchr(line,'#')=0;
  while ((line[strlen(line)-1]==' ')||(line[strlen(line)-1]=='\t'))
      line[strlen(line)-1]=0;
  if (!*line) continue;

  cmd = line;
  what = line;
  while ((*what!=' ')&&(*what!='\t')&&(*what)) what++;
  if (!*what )
  {
   ConsolePrintf("SMSSMTP:Bad rule %s\r\n",line);
   continue;
  }
  *what++=0;
  while ((*what==' ')||(*what=='\t')) what++;
  arg2 = what;
  while ((*arg2!=' ')&&(*arg2!='\t')&&(*arg2)) arg2++;
  *arg2++=0;
  while ((*arg2==' ')||(*arg2=='\t')) arg2++;

  if ( !strcmpi(cmd,"fail") )
  {
    AppendFail(what,arg2);
  }else
  if ( !strcmpi(cmd,"mime") )
  {
    AppendMime(what,arg2);
  }else
  if ( !strcmpi(cmd,"directory") )
  {
   chdir(what);
  }else
  if ( !strcmpi(cmd,"AccessLog") )
  {
   strncpy(LogFile,what,0x100);
   LogFile[0xFF]=0;
  }else
  if ( !strcmpi(cmd,"StatusURL") )
  {
   strncpy(StatusURL,what,0x100);
   StatusURL[0xFF]=0;
  }else
  if ( !strcmpi(cmd,"StatusPassword") )
  {
   strncpy(StatusPassword,what,0x40);
   StatusPassword[0x3F]=0;
  }else
  if ( !strcmpi(cmd,"ProxyServer") )
   {
    strncpy(ProxyCache,what,0x40);
   }else
  if ( !strcmpi(cmd,"ProxyPort") )
   {
    ProxyPort=atoi(what);
   }else
  if ( !strcmpi(cmd,"Port") )
   {
    MyPort=atoi(what);
   }else
  {
   ConsolePrintf("NOADVERT:Bad config\r\n");
   continue;
  }
 }
 fclose(f);

}
