#define N_PLAT_NLM
#define N_IAPX386

#include <sys/types.h>
#include <conio.h>
#include <fcntl.h>
#include <nwtypes.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <io.h>
#include <process.h>
#include <arpa/inet.h>
#include <time.h>

#include "rules.h"
#include "stat.h"
#include "headers.h"
#include "misc.h"
#include "logs.h"

struct sockaddr_in server_sockaddr;
struct sockaddr_in client_sockaddr;
struct sockaddr_in proxy_sockaddr;
int s;


int ProxyStopped;
char StopReason[0x100];

int FailedPages;
int TotalRequests;
int TotalBytes;
int CurrentConnections;
long StartTime;

char err_badreq[] = CACHE_HEADER
                    "Error: Your browser sent bad request."
                    HTML_FOOTER;
char err_nomem[] = CACHE_HEADER
                   "Error - Not enough memory!"
                   HTML_FOOTER;
char err_unimplemented[] = CACHE_HEADER
                           "Error: This feature is not implemented.<p>"
                           "Please contact author <a href=\"mailto:martin@tdp.cz\">martin@tdp.cz</a>."
                           HTML_FOOTER;
char err_noproxy[] = CACHE_HEADER
                     "Error: Unable to connect to my proxy server."
                     HTML_FOOTER;

char err_fail[] = CACHE_HEADER
                  "<center><font size=6 color=#ff0000>Disabled URL</font></center><p>"
                  "This url is disabled."
                  HTML_FOOTER;

char err_lamer[] = CACHE_HEADER
                  "<center><font size=6 color=#ff0000>HTTP/1.0 404</font></center><p>"
                  "404 Lamer detected."
                  HTML_FOOTER;

char err_unauthorized[] =
                  "HTTP/1.0 401 OK\n"
                  "Content-type: text/html\n"
                  "Www-Authenticate: Basic realm=\"Noadvert.NLM_proxy_redirector\"\n"
                  "\n"
                  HTML_HEADER
                  "<center><font size=6 color=#ff0000>Unauthorized access</font></center><p>"
                  "You must enter correct username and password to show noadvert proxy "
                  "redirector status. Password is set in file <code>SYS:/ETC/NOADVERT.CFG</code>.<p>"
                  HTML_FOOTER;


void daughter(void *parm)
{
  int s;
  long remote_addr;
  int proxy;
  int rc;
  char *request;
  char *line;
  char *method;
  char *url;
  char *proto;
  char *fail_file;

  CurrentConnections++;
  s  = ((long*)parm)[0];
  remote_addr = ((long*)parm)[1];
  delete parm;

  request = (char*)malloc(8192);
  if (!request)
   {
    write(s,err_nomem,strlen(err_nomem));
    close(s);
    CurrentConnections--;
    return;
   }
  line = (char*)malloc(8192);
  if (!line)
   {
    write(s,err_nomem,strlen(err_nomem));
    delete request;
    close(s);
    CurrentConnections--;
    return ;
   }

  sockgets(s,request,8192);
  if ( request[strlen(request)-1]=='\n' )
    request[strlen(request)-1]=0;

  if (!strlen(request))
   {
    write(s,err_badreq,strlen(err_badreq));
    delete request;
    delete line;
    close(s);
    CurrentConnections--;
    return;
   }

  TotalRequests++;

  method = request;
  url = request;
  while ((*url)&&(*url!=' ')) url++;
  *url++=0;
  while ((*url)&&(*url==' ')) url++;
  proto = url;
  while ((*proto)&&(*proto!=' ')) proto++;
  *proto++=0;
  while ((*proto)&&(*proto==' ')) proto++;

  if (VerifyFail(url,&fail_file))
  {
   FailedPages++;
   if ((fail_file)&&(*fail_file))
    {
     int handle;

     handle = open(fail_file,O_BINARY|O_RDONLY);
     if (handle!=-1)
      {
       // Write HTTP/1.0 Header
       sprintf(line,"HTTP/1.0 200 OK\n");
       write(s,line,strlen(line));
       sprintf(line,"Content-type: %s\n",GetMime(fail_file));
       write(s,line,strlen(line));
       sprintf(line,"Content-length: %lu\n",filelength(handle));
       write(s,line,strlen(line));
       sprintf(line,"\n");
       write(s,line,strlen(line));

       while ((rc = read(handle,line,8190))>0)
        rc = write(s,line,rc);
       close(handle);
      }else
       write(s,err_fail,strlen(err_fail));
    }else
    {
     write(s,err_fail,strlen(err_fail));
    }
   delete request;
   delete line;
   close(s);
   CurrentConnections--;
   return;
  }


  if (!stricmp(method,"GET"))
  {
  if (!strnicmp(url,StatusURL,strlen(StatusURL)))
   {
    ShowStat(url+strlen(StatusURL),s);
    delete request;
    delete line;
    CurrentConnections--;
    close(s);
    return;
   }

  if (ProxyStopped)
   {
    ShowStop(s);
    delete request;
    delete line;
    CurrentConnections--;
    close(s);
    return;
   }

  NALog(remote_addr,url,time(NULL));


  proxy_sockaddr.sin_addr.s_addr = inet_addr(ProxyCache);
  if (proxy_sockaddr.sin_addr.s_addr == -1)
   {
    write(s,err_noproxy,strlen(err_noproxy));
    delete line;
    delete request;
    close(s);
    CurrentConnections--;
    return;
   }

  proxy_sockaddr.sin_family = AF_INET;
  proxy_sockaddr.sin_port = htons(ProxyPort);

  proxy = socket(PF_INET, SOCK_STREAM, 0);
  if (proxy == -1)
   {
    write(s,err_noproxy,strlen(err_noproxy));
    delete line;
    delete request;
    close(s);
    CurrentConnections--;
    return;
   }

  rc = connect(proxy,(struct sockaddr *)&proxy_sockaddr,sizeof (proxy_sockaddr));
  if (rc == -1)
   {
    write(s,err_noproxy,strlen(err_noproxy));
    delete line;
    delete request;
    close(s);
    CurrentConnections--;
    return;
   }

  sprintf(line,"%s %s %s\n",method,url,proto);
  write(proxy,line,strlen(line));

  while (1)
   {
    sockgets(s,line,8190);
    if (! *line )
     break;

    if (1)
     {
      rc = write(proxy,line,strlen(line));
      if (rc == -1)
       {
        write(s,err_badreq,strlen(err_badreq));
        delete request;
        delete line;
        close(s);
        close(proxy);
        CurrentConnections--;
        return;
       }
     }
    if (!strcmp(line,"\n") )
     break;
   }

  while (1)
   {
    sockgets(proxy,line,8190);
    if (! *line )
     {
      close(s);
      close(proxy);
      delete request;
      delete line;
      CurrentConnections--;
      return;
     }

    if (strnicmp(line,"Set-Cookie:",11))
     rc = write(s,line,strlen(line));
    if (!strcmp(line,"\n") )
     break;
   }



  while ((rc = read(proxy,line,8190))>0)
   {
     TotalBytes+=rc;
//     ConsolePrintf("%s: %u\n",url,TotalBytes);
     rc = write(s,line,rc);
   }

  close(s);
  close(proxy);
  delete request;
  delete line;
  CurrentConnections--;
  return;
  }else
  if (!stricmp(method,"POST"))
  {
   int ContentLength;


  if (ProxyStopped)
   {
    ShowStop(s);
    delete request;
    delete line;
    CurrentConnections--;
    close(s);
    return;
   }

   proxy_sockaddr.sin_addr.s_addr = inet_addr(ProxyCache);
   if (proxy_sockaddr.sin_addr.s_addr == -1)
    {
     write(s,err_noproxy,strlen(err_noproxy));
     delete line;
     delete request;
     close(s);
     CurrentConnections--;
     return;
    }

   proxy_sockaddr.sin_family = AF_INET;
   proxy_sockaddr.sin_port = htons(ProxyPort);

   proxy = socket(PF_INET, SOCK_STREAM, 0);
   if (proxy == -1)
   {
    write(s,err_noproxy,strlen(err_noproxy));
    delete line;
    delete request;
    close(s);
    CurrentConnections--;
    return;
   }

   rc = connect(proxy,(struct sockaddr *)&proxy_sockaddr,sizeof (proxy_sockaddr));
   if (rc == -1)
   {
    write(s,err_noproxy,strlen(err_noproxy));
    delete line;
    delete request;
    close(s);
    CurrentConnections--;
    return;
   }

   sprintf(line,"%s %s %s\n",method,url,proto);
   write(proxy,line,strlen(line));

   ContentLength=0;

   while (1)
   {
    sockgets(s,line,8190);
    if (! *line )
     break;

    if (1)
     {
      rc = write(proxy,line,strlen(line));
      if (rc == -1)
       {
        write(s,err_badreq,strlen(err_badreq));
        delete request;
        delete line;
        close(s);
        close(proxy);
        CurrentConnections--;
        return;
       }
     }

    if (!strnicmp(line,"Content-length:",15))
     {
      char *len;

      if (line[strlen(line)-1]=='\n') line[strlen(line)-1]=0;
      len = line+16;
      while ((*len)&&(*len==' ')) len++;
      ContentLength=atoi(len);
     }

    if (!strcmp(line,"\n") )
     break;
   }

   // put POST data
   while ((rc = read(s,line,ContentLength>8190?8190:ContentLength))>0)
   {
    TotalBytes+=rc;
    ContentLength-=rc;
    rc = write(proxy,line,rc);
    if (!ContentLength) break;
   }

   // Read HTTP Header
   while (1)
   {
    sockgets(proxy,line,8190);
    //ConsolePrintf("[%s]",line);
    if (! *line )
     {
      close(s);
      close(proxy);
      delete request;
      delete line;
      CurrentConnections--;
      return;
     }

    // if (strnicmp(line,"Set-Cookie:",12))
    rc = write(s,line,strlen(line));
    if (!strcmp(line,"\n") )
     break;
   }



   while ((rc = read(proxy,line,8190))>0)
   {
     TotalBytes+=rc;
//     ConsolePrintf("%s: %u\n",url,TotalBytes);
     rc = write(s,line,rc);
   }

   close(s);
   close(proxy);
   delete request;
   delete line;
   CurrentConnections--;
   return;
  }else
  {
   write(s,err_unimplemented,strlen(err_badreq));
   delete request;
   delete line;
   close(s);
   CurrentConnections--;
   return;
  }
}

void UnloadFunc()
{
 close(s);
 NAStopLogs();
 ConsolePrintf("\rTCP: Unloaded.\n");
}

void main()
{
  int rc,len;
  long *arg;


  StartTime = time( NULL );

  ProxyStopped=0;
  strcpy(StopReason,"");
  strcpy(ProxyCache,"");
  ProxyPort=0;
  FailedPages=0;
  TotalRequests=0;
  TotalBytes=0;
  CurrentConnections=0;
  LoadTables();

  if ((!ProxyCache[0])||(!ProxyPort))
   {
    ConsolePrintf("\rProxy server has not been set!\n");
    return;
   }

  if (!MyPort)
   {
    ConsolePrintf("\rPort has not been set!\n");
    return;
   }

 RenameThread(GetThreadID(),"Noadvert:Main()");

  ConsolePrintf("\rProxy Cache server: %s:%u\n\r",ProxyCache,ProxyPort);
  ConsolePrintf("\rNoadvert.nlm port:  %u\n\r",MyPort);
  ConsolePrintf("\rStatus URL:         %s %s\n\r",StatusURL,StatusPassword[0]?"  (password protected)":"");

	s = socket(PF_INET, SOCK_STREAM, 0);
	if (s == -1) {
		perror("socket");
		exit(1);
	}

  NAInitLogs(LogFile,100,60);


  atexit(UnloadFunc);

  server_sockaddr.sin_family = AF_INET;
  server_sockaddr.sin_port = htons(MyPort);

	rc = bind(s, (struct sockaddr *) & server_sockaddr,
		  sizeof (server_sockaddr));
	if (rc == -1) {
		perror("bind");
		exit(1);
	}

	rc = listen(s, 5);
	if (rc == -1) {
		perror("listen");
		exit(1);
	}


	for (;;) {
    len = sizeof (client_sockaddr);
    arg = new long[2];
    if (!arg)
     {
      exit(1);
     }
    arg[0] = accept(s, (struct sockaddr *) & client_sockaddr, &len);
    if (arg[0] == -1) {
			perror("accept");
			close(s);
			exit(1);
		}
    arg[1] = client_sockaddr.sin_addr.S_un.S_addr;
    rc = BeginThread(daughter, (void *) NULL, 8192, (void *) arg);
	}
}
